setClass("aRTproxy", contains = "aRTcomponent")

setMethod("initialize", "aRTproxy", function(.Object,
                                             aRTlayer,
                                             loadgeom = FALSE,
                                             loadatt = TRUE)
{
  if (!is.object(aRTlayer) || class(aRTlayer) != "aRTlayer")
    stop("Argument \"aRTlayer\" must an object of aRTlayer\n")

  out <- .Call("cppProxy",
               aRTlayer@pointer,
               list(loadgeom=loadgeom,
                    loadatt=loadatt),
               PACKAGE="aRT")

  if (is.null(out))
    stop("Could not create the aRTproxy object\n")

  .Object@pointer <- out
  reg.finalizer(.Object@pointer, .aRTremove)
  .Object
})

setGeneric("getNext",  function(x)   standardGeneric("getNext"))

# TODO: return all data in sp format
setMethod("getNext", "aRTproxy", function(x) {
 .Call("cppGetNext",
       x@pointer,
       PACKAGE="aRT")
})

