#  aRT : API R - TerraLib                                                
#  Copyright (C) 2003-2005  LEG                                          
#                                                                        
#  This program is free software; you can redistribute it and/or modify  
#  it under the terms of the GNU General Public License as published by  
#  the Free Software Foundation; either version 2 of the License, or     
#  (at your option) any later version.                                   
#                                                                        
#  This program is distributed in the hope that it will be useful,       
#  but WITHOUT ANY WARRANTY; without even the implied warranty of        
#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         
#  GNU General Public License for more details.                          
#                                                                        
#  You should have received a copy of the GNU Lesser General Public      
#  License along with this library.

setClass("aRTvisual",
    representation(color   = "matrix",
	               ccolor  = "matrix",
                   style   = "integer",
                   transp  = "integer",
                   ctransp = "integer",
                   cwidth  = "integer",
                   width   = "integer",
				   size    = "integer")
)

setMethod("initialize",
          "aRTvisual",
          function(.Object,
                   color   = "white",
				   ccolor  = "black",
                   style   = 1,
                   transp  = 0,
                   ctransp = 0,
                   cwidth  = 1,
                   width   = 1,
				   size    = 5)
{
   .Object@color   = col2rgb(color)
   .Object@ccolor  = col2rgb(ccolor)
   .Object@style   = as.integer(style)
   .Object@transp  = as.integer(transp)
   .Object@ctransp = as.integer(ctransp)
   .Object@cwidth  = as.integer(cwidth)
   .Object@width   = as.integer(width)
   .Object@size    = as.integer(size)
   .Object
})

setMethod("show", "aRTvisual", function(object)
{
	cat(paste("Object of Class aRTvisual\n\n"))
	
	cat(paste("Color: ",        object@color,  "\n"))
	cat(paste("Transparency: ", object@transp, "\n"))
	cat(paste("Width: ",        object@width,  "\n"))
	return(invisible())
})

setGeneric("getVisual",  function(object) standardGeneric("getVisual"))
setGeneric("setVisual",  function(object, visual, attribute = NULL, mode = "e") standardGeneric("setVisual"))

setMethod("getVisual", "aRTtheme", function(object) {
  params = .Call("cppGetVisual", object@pointer, PACKAGE="aRT")
  return (new("aRTvisual",
             color = params$color,
			 transp = params$transp))
})

setMethod("setVisual", "aRTtheme", function(object, visual, attribute = NULL, mode = "e") {
  .Call("cppSetVisual",
        object@pointer,
		list(visual = getVisual(visual),
		     attribute = attribute,
			 mode = mode),
		PACKAGE="aRT")
  return(invisible())
})

setMethod("getVisual", "aRTvisual", function(object) {
	visual = object
    list(color   = visual@color,
	     ccolor  = visual@ccolor,
         style   = visual@style,
         width   = visual@width,
         cwidth  = visual@cwidth,
	     transp  = visual@transp,
		 ctransp = visual@ctransp,
		 size    = visual@size)
})

# default values for all geometric types when creating themes
visualPoints = function()
{
  new("aRTvisual", color="black", sty=7, size=6)
}

visualLines = function()
{
  new("aRTvisual", color="black", width=5, cwid=7, sty=0)
}

visualPolygons = function()
{
  new("aRTvisual", color="white", ccolor="black", width=5, cwid=7, transp=100)
}

visualRaster = function()
{
  new("aRTvisual", color = terrain.colors(10))
}

