\name{aRTlayer-getRelation}
\docType{object}
\alias{getRelation,aRTlayer-method}
\alias{getRelation}
\alias{contain}
\alias{overlap}
\alias{cross}
\alias{disjoint}
\alias{within}
\alias{intersects}
\alias{equal}
\alias{cover}

\title{"aRTlayer getRelation"}

\description{Returns elements of a given layer that satisfy a given spatial relation.
The relation can be in a different layer.}

\section{Arguments}{
  \describe{
  \item{object:}{The target layer.}
  \item{relation:}{Which relation is to be used.}
   \describe{
        \item{"c"}{Contains}
        \item{"o"}{Overlaps}
        \item{"x"}{Crosses}
        \item{"d"}{Disjoint}
        \item{"t"}{Touches}
        \item{"w"}{Within}
        \item{"i"}{Intersects}
        \item{"e"}{Equals}
        \item{"v"}{CoVers}
        \item{"y"}{Covered bY}
   }
  \item{layer:}{The layer which the spatial relation must satisfy}
  \item{ids:}{The selected ids of layer to be used. If NULL, all the elements of layer will be used}
  }
}

\examples{
\dontrun{

}}

\references{\url{http://www.est.ufpr.br/aRT}}
\author{Pedro Ribeiro de Andrade Neto}
\keyword{methods}

\seealso{
   See \code{aRTlayer-class} to the description of this class.
}

% vim: syntax=tex
