# Exemplo de relacoes espaciais utilizando os
# trs tipos de geometria.
# Este exemplo utiliza os dados de Recife
#
# (C) 2005 LEG

require(aRT)

a = new("aRT")

if(any(showDbs(a)=="recife")) deleteDb(a, "recife", force=T)

db = new("aRTdb",a,db="recife", c=T)

lbairros    = new("aRTlayer", db, l="Bairros", c=T)
larmadilhas = new("aRTlayer", db, l="Armadilhas", c=T)
ldrenagem   = new("aRTlayer", db, l="Drenagem", c=T)

data(recife.districts)
data(recife.points)
data(recife.sewers)

addPolygons(lbairros,    recife.districts)
addPoints  (larmadilhas, recife.points)
addLines   (ldrenagem,   recife.sewers)

new("aRTtable",lbairros,   "t_bairros",   c=T)
new("aRTtable",larmadilhas,"t_armadilhas",c=T)
new("aRTtable",ldrenagem,  "t_drenagem",  c=T)

# isto demora um pouco... pegar as geometrias dos layers
# utilizados para nao precisar fazer mais
getGeometry(lbairros)   ->geobairros
getGeometry(larmadilhas)->geoarmadilhas
getGeometry(ldrenagem)  ->geodrenagem

par(mfcol=c(2,2), mar=c(3,3,.5,.5))

# plotando bairros e armadilhas
plot(geobairros, col="red")
plot(geoarmadilhas, add=T)

# plotando rede de drenagem da cidade
plot(geobairros, col="gray", lty=0)
plot(geodrenagem, add=T, col="blue")

## Relacoes espaciais
# 1. todos os bairros que Contem armadilhas
getRelation(lbairros, "c", larmadilhas)->rel1

# 2. todos os vizinhos (touch) dos bairros que possuem armadilhas
getRelation(lbairros, "t", id=rel1)->rel2

plot(geobairros, col="gray", lty=0)
plot(geobairros, col="green", add=T, id=rel2)
plot(geobairros, col="yellow", add=T, id=rel1)
# nao desenhei as armadilhas porque senao nao d pra ver os bairros (fica preto)
#plot(geoarmadilhas, add=T)

# 3. drenagens que cruzam os bairros que tem armadilhas
getRelation(ldrenagem, "x", layer=lbairros, id=rel1)->rel3

# 4. drenagens que estao contidas (within) nos bairros que tem armadilhas
getRelation(ldrenagem, "w", layer=lbairros, id=rel1)->rel4

plot(geobairros, col="gray", lty=0, id=rel1)
plot(geobairros, col="gray", lty=0, add=T)
plot(geobairros, col="yellow", lty=0, id=rel1, add=T)
plot(geodrenagem, add=T)
plot(geodrenagem, add=T, col="green", id=rel3)
plot(geodrenagem, add=T, col="red", id=rel4)

